unit XfExploderImpl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, XExploder_TLB, StdCtrls, ExtCtrls;

type
  TXfExploder = class(TActiveForm, IXfExploder)
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    FEvents: IXfExploderEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure Initialize; override;
    function Get_Active: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: TColor; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: Font; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_WindowState: TxWindowState; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: TColor); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: Font); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure Set_WindowState(Value: TxWindowState); safecall;
  public
    { Public declarations }
    x, y: Integer;
  end;

implementation

uses ComServ, MmSystem;

{$R *.DFM}

{ TXfExploder }

procedure TXfExploder.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IXfExploderEvents;
end;

procedure TXfExploder.Initialize;
begin
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
end;

function TXfExploder.Get_Active: WordBool;
begin
  Result := Active;
end;

function TXfExploder.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TXfExploder.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TXfExploder.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TXfExploder.Get_Color: TColor;
begin
  Result := Color;
end;

function TXfExploder.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TXfExploder.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TXfExploder.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TXfExploder.Get_Font: Font;
begin
  GetOleFont(Font, Result);
end;

function TXfExploder.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TXfExploder.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TXfExploder.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TXfExploder.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TXfExploder.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TXfExploder.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TXfExploder.Get_WindowState: TxWindowState;
begin
  Result := Ord(WindowState);
end;

procedure TXfExploder.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TXfExploder.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TXfExploder.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TXfExploder.Set_Color(Value: TColor);
begin
  Color := Value;
end;

procedure TXfExploder.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TXfExploder.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TXfExploder.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TXfExploder.Set_Font(const Value: Font);
begin
  SetOleFont(Font, Value);
end;

procedure TXfExploder.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TXfExploder.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TXfExploder.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TXfExploder.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TXfExploder.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TXfExploder.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

procedure TXfExploder.Set_WindowState(Value: TxWindowState);
begin
  WindowState := TWindowState(Value);
end;

procedure TXfExploder.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TXfExploder.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TXfExploder.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TXfExploder.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TXfExploder.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TXfExploder.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TXfExploder.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TXfExploder.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

const
  Pts: array [1..16, 1..2] of Integer =
   ((0, 0), (800, 0), (800, 800),
   (400, 800), (400, 440), (470, 415),
   (530, 210), (700, 40), (415, 140),
   (240, -30), (360, 280), (100, 300), (400, 320),
   (400, 800), (0, 800), (0, 0));

procedure TXfExploder.Button1Click(Sender: TObject);
var
  HRegion1: THandle;
  Col: TColor;
  IeHandle: THandle;
  ModuleName: string;
begin
  Col := Color;
  Color := clRed;
  IeHandle := FindWindow ('IEFrame', nil);
  if IeHandle = 0 then
    raise Exception.Create ('IE non found');
  SetWindowText (IeHandle, 'Internet Exploder!');
  SetLength (ModuleName, 1000);
  GetModuleFileName (HInstance, pChar (ModuleName), 1000);
  ShowMEssage (ExtractFilePath (PChar (ModuleName)) + 'boom.wav');
  PlaySound (PChar (
    ExtractFilePath (PChar (ModuleName)) + 'boom.wav'),
    0, snd_sync);
  HRegion1 := CreatePolygonRgn (Pts,
    sizeof (Pts) div 8,
    alternate);
  SetWindowRgn (
    IeHandle, HRegion1, True);
  Color := Col;
end;

procedure TXfExploder.Button2Click(Sender: TObject);
begin
  Timer1.Enabled := True;
  Beep;
  x := 0;
  y := 0;
end;

procedure TXfExploder.Timer1Timer(Sender: TObject);
var
  Hr1, hr2, hr3: THandle;
  IeHandle: THandle;
begin
  x := (x + 10) mod screen.width;
  y := (y + 10) mod screen.height;

  IeHandle := FindWindow ('IEFrame', nil);
  if IeHandle = 0 then
    raise Exception.Create ('IE non found');

   hr1 := CreateEllipticRgn (x - 100, y - 100,
     x + 100, y + 100);
   hr2 := CreateEllipticRgn (x - 100, y - 100,
     x + 100, y + 100);
   hr3 := CreateEllipticRgn (x - 100, y - 100,
     x + 100, y + 100);

   GetWindowRgn (IeHandle, hr2);
   CombineRgn (hr3, hr2, hr1, rgn_xor);
  SetWindowRgn (
    IeHandle, HR3, True);
  InvalidateRect (GetDesktopWindow, nil, False);

end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TXfExploder,
    Class_XfExploder,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL);
end.
