unit AutoFontChanger;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type
  TAutoFontChanger = class(TComponent)
  private
    FTimer: TTimer;
    FInterval: Cardinal;
    FFixedSize: Boolean;
  protected
    procedure OnTimer (Sender: TObject);
    procedure SetInterval (Value: Cardinal);
  public
    constructor Create (AOwner: TComponent); override;
  published
    property Interval: Cardinal
      read FInterval write SetInterval default 10000;
    property FixedSize: Boolean
      read FFixedSize write FFixedSize default True;
  end;

procedure Register;

implementation

constructor TAutoFontChanger.Create (AOwner: TComponent);
begin
  inherited;
  fTimer := TTimer.Create (self);
  fTimer.Enabled := True;
  fInterval := 10000;
  fTimer.Interval := fInterval;
  fTimer.OnTimer := OnTimer;
  fFixedSize := True;
end;

procedure TAutoFontChanger.SetInterval (Value: Cardinal);
begin
  fInterval := Value;
  fTimer.Interval := fInterval;
end;

procedure TAutoFontChanger.OnTimer (Sender: TObject);
begin
  (Owner as TForm).Font.Name :=
    Screen.Fonts [Random (Screen.Fonts.Count)];
  if not FFixedSize then
    (Owner as TForm).Font.Size := Random (36);
end;

procedure Register;
begin
  RegisterComponents('Fun', [TAutoFontChanger]);
end;

end.
