unit color2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TFormColor2 = class(TForm)
    LabelRed: TLabel;
    LabelGreen: TLabel;
    LabelBlue: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Label1: TLabel;
    Label2: TLabel;
    TrackRed: TTrackBar;
    TrackGreen: TTrackBar;
    TrackBlue: TTrackBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure TrackRedChange(Sender: TObject);
  public
    procedure InitColor (Col: TColor);
    function FinalColor: TColor;
  end;

var
  FormColor2: TFormColor2;

implementation

{$R *.DFM}

procedure TFormColor2.InitColor (Col: TColor);
begin
  TrackBlue.Position := GetBValue (Col) div 16;
  TrackRed.Position := GetRValue (Col) div 16;
  TrackGreen.Position := GetGValue (Col) div 16;
  TrackRedChange (self);
end;

function TFormColor2.FinalColor: TColor;
begin
  FinalColor := RGB (TrackRed.Position * 16,
    TrackBlue.Position * 16, TrackGreen.Position * 16);
end;

procedure TFormColor2.TrackRedChange(Sender: TObject);
begin
  LabelRed.Caption := 'Red: ' +
    IntToStr (TrackRed.Position * 16);
  LabelGreen.Caption := 'Green: ' +
    IntToStr (TrackGreen.Position * 16);
  LabelBlue.Caption := 'Blue: ' +
    IntToStr (TrackBlue.Position * 16);
  Shape1.Brush.Color := RGB (TrackRed.Position * 16,
    TrackBlue.Position * 16, TrackGreen.Position * 16);
  Shape2.Pen.Color := RGB (TrackRed.Position * 16,
    TrackBlue.Position * 16, TrackGreen.Position * 16);
end;

end.
