unit Copyrigh;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DsgnIntf;

type
  TFunCopyright = class(TComponent)
  private
    FCopyright, FAuthor: string;
    FDummy1, FDummy2: string;
    FLabel: TLabel;
  protected
    procedure SetLabel (Value: TLabel);
  public
    constructor Create (AOwner: TComponent); override;
  published
    property Copyright: string
      read FCopyright write FDummy1;
    property Author: string
      read FAuthor write FDummy2;
    property OutputLabel: TLabel
      read FLabel write SetLabel;
  end;

  TFunAboutEditor = class (TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

procedure Register;

implementation

constructor TFunCopyright.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);

  FAuthor := 'Marco Cant';
  FCopyright := 'MC 1997';
  if csDesigning in ComponentState then
  begin
    with Owner as TForm do
      Caption := Caption +
        ' using a component by ' + FAuthor;
    with Application do
      Title := Title +
      ' using a component by ' + FAuthor;
    ShowMessage ('This form is using a component by ' +
      FAuthor);
  end
  else
    ShowMessage ('This program uses a component by ' +
      FAuthor);
end;

procedure TFunCopyright.SetLabel (Value: TLabel);
begin
  if Value <> FLabel then
  begin
    FLabel := Value;
    FLabel.Caption := FCopyright;
  end;
end;

function TFunAboutEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;

function TFunAboutEditor.GetVerb (Index: Integer): string;
begin
  case Index of
    0: Result :=
      (Component as TFunCopyright).FAuthor;
    1: Result :=
      (Component as TFunCopyright).FCopyright;
    2: Result :=
      '&About my great component...';
  end;
end;

procedure TFunAboutEditor.ExecuteVerb (Index: Integer);
begin
  MessageDlg ('Send a 20$ check, a 20$ bill, 2 10$ bills...'#13 +
    'or 80 quarters to me, and I''ll be happy',
    mtInformation, [mbOK], 0);
end;

procedure Register;
begin
  RegisterComponents('FunSide', [TFunCopyright]);
  RegisterComponentEditor (TFunCopyright, TFunAboutEditor);
end;

end.
