unit ExpGForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, ExpGResF, StdCtrls, Buttons, ComCtrls;

type
  TGameExpertForm = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    UnitName: string;
  end;

var
  GameExpertForm: TGameExpertForm;

implementation

{$R *.DFM}

procedure TGameExpertForm.BitBtn1Click(Sender: TObject);
var
  F: System.text;
begin
  ResultForm := TResultForm.Create (Application);
  ResultForm.Caption := Edit1.Text;
  with ResultForm.DrawGrid1 do
  begin
    ColCount := UpDown1.Position;
    RowCount := UpDown2.Position;
    Width := ColCount * DefaultColWidth + 5;
    Height := RowCount * DefaultRowHeight + 5;
    ResultForm.Width := Width + 20;
    ResultForm.Height := Height + 20;
  end;

  {generate the first part of the unit source}
  System.Assign(f,UnitName+'.PAS');
  System.Rewrite(f);

  writeln(f,'unit ',ExtractFileName(UnitName),';');
  writeln(f,'interface');
  writeln(f,'uses');
  writeln(f,'  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,');
  writeln(f,'  Forms, Dialogs, ExtCtrls;');
  writeln(f);
  writeln(f,'type');
  writeln(f,'  TResultForm = class(TForm)');
  writeln(f,'    DrawGrid1: TDrawGrid;');
  writeln(f,'    procedure FormCreate(Sender: TObject);');
  writeln(f,'    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Longint;');
  writeln(f,'      Rect: TRect; State: TGridDrawState);');
  writeln(f,'  private');
  writeln(f,'    Bmp: TBitmap;      {temporary bitmap}');
  writeln(f,'  public');
  writeln(f,'    { Public declarations }');
  writeln(f,'  end;');
  writeln(f);
  writeln(f,'var');
  writeln(f,'  ResultForm: TResultForm;');
  writeln(f);
  writeln(f,'implementation');
  writeln(f);
  writeln(f,'{$R *.DFM}');
  writeln(f,'{$R BITMAPS.RES}');
  writeln(f);
  writeln(f,'procedure TResultForm.FormCreate(Sender: TObject);');
  writeln(f,'begin');
  writeln(f,'  Bmp := TBitmap.Create;');
  writeln(f,'end;');
  writeln(f);
  writeln(f,'procedure TResultForm.DrawGrid1DrawCell(Sender: TObject;');
  writeln(f,'  Col, Row: Longint;');
  writeln(f,'  Rect: TRect; State: TGridDrawState);');
  writeln(f,'begin');
  writeln(f,'  Bmp.Handle := LoadBitmap (HInstance, PChar (''M'' + IntToStr (Col * Row mod 9)));');
  writeln(f,'  DrawGrid1.Canvas.Draw (Rect.Left, Rect.Top, Bmp);');
  writeln(f,'end;');
  writeln(f);
  writeln(f,'end.');
  System.Close(f);

  ModalResult := mrOk
end;

end.
