unit ExpBlank;

interface

uses
  Windows, Dialogs, ExptIntf,
  ToolIntf, FileCtrl, Controls;

type
  TBlankExpert = class (TIExpert)
  public
    function GetStyle: TExpertStyle; override;
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HBITMAP; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;
    procedure Execute; override;
  end;

  procedure Register;

implementation

  function TBlankExpert.GetStyle: TExpertStyle;
  begin
    Result := esStandard;
  end;

  function TBlankExpert.GetName: String;
  begin
    Result := 'Blank Expert'
  end;

  function TBlankExpert.GetComment: String;
  begin
    Result := '';  // no thanks
  end;

  function TBlankExpert.GetGlyph: HBITMAP;
  begin
    Result := 0;  // no thanks
  end;

  function TBlankExpert.GetState: TExpertState;
  begin
    Result := [esEnabled];
  end;

  function TBlankExpert.GetIDString: String;
  begin
    Result := 'MarcoCantu.BlankExpert'
  end;

  function TBlankExpert.GetMenuText: String;
  begin
    Result := '&Blank Expert...'
  end;

  procedure TBlankExpert.Execute;
  var
    DirName: string;
  begin
    if MessageDlg ('Are you sure you want to exit'#13 +
      'from the current project, saving it?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      ToolServices.SaveProject;
      ToolServices.CloseProject;
      SelectDirectory (DirName,
        [sdAllowCreate, sdPerformCreate, sdPrompt], 0);
      ToolServices.OpenProject (DirName + '\Project1.dpr');
    end;
  end;

  procedure Register;
  begin
    RegisterLibraryExpert(TBlankExpert.Create)
  end;

end.
