unit pe_col;

interface

uses
  SysUtils,
  WinTypes,
  WinProcs,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  DsgnIntf,
  ComCtrls;

type
  TMyColorProperty = class (TColorProperty)
  public
    procedure Edit; override;
  end;

procedure Register;

implementation

uses Color1, Color2;

{property editor methods}

var
  nEditor: Integer;

procedure TMyColorProperty.Edit;
begin
  try
    case nEditor of
      0: begin
        FormColor1 := TFormColor1.Create (Application);
        try
          FormColor1.InitColor (
            StringToColor (GetValue));
          if FormColor1.ShowModal = mrOK then
            SetValue (ColorToString (
              FormColor1.FinalColor));
        finally
          FormColor1.Free;
        end;
      end;
      1: begin
        FormColor2 := TFormColor2.Create (Application);
        try
          FormColor2.InitColor (
            StringToColor (GetValue));
          if FormColor2.ShowModal = mrOK then
            SetValue (ColorToString (
              FormColor2.FinalColor));
        finally
          FormColor2.Free;
        end;
      end;
      2: inherited Edit;
    end;
  finally
    nEditor := (nEditor + 1) mod 3;
  end;
end;

procedure Register;
begin
  RegisterPropertyEditor (TypeInfo(TColor),
    TComponent, '', TMyColorProperty);
end;

initialization
  nEditor := 0;
end.

